{{ $appSection := "url-proxy" -}}
{{ $appName := (index . "Values" $appSection "name") -}}
{{- if index . "Values" $appSection "enabled" -}}
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ $appName }}
  labels:
    app.kubernetes.io/name: {{ $appName }}
    {{- include "golemio.labels" . | nindent 4 }}
  annotations:
    {{- include "golemio.annotations" . | nindent 4 }}
spec:
  replicas: {{ index .Values $appSection "replicas" }}
  strategy: {{- include "golemio.rollingUpdate" (index . "Values" $appSection) | nindent 4 }}
  selector:
    matchLabels:
      app.kubernetes.io/name: {{ $appName }}
      {{- include "golemio.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      labels:
        app.kubernetes.io/name: {{ $appName }}
        {{- include "golemio.labels" . | nindent 8 }}
      annotations:
        {{- include "golemio.annotations" . | nindent 8 }}
    spec:
      automountServiceAccountToken: false
      containers:
        - name: {{ $appName }}
          image: {{ include "golemio.imageName" (list . $appSection) | quote }}
          imagePullPolicy: {{ .Values.global.pullPolicy }}
          ports:
          - containerPort: {{ index . "Values" $appSection "port" }}
          {{- if index . "Values" $appSection "inspector" "enabled" }}
          - containerPort: {{ index . "Values" $appSection "inspector" "port" }}
          {{- end }}
          resources:
            {{ index .Values $appSection "resources" | toYaml | nindent 12 }}
          securityContext:
            allowPrivilegeEscalation: false
            runAsNonRoot: true
            runAsUser: 1001
            capabilities:
              drop: [ "all" ]
          env:
            - name: APP_NAME
              value: {{ index .Values $appSection "name" }}
            - name: NODE_ENV
              value: {{ index .Values $appSection "nodeEnv" }}
            - name: LOG_LEVEL
              value: {{ index .Values $appSection "logLevel" }}
            - name: NODE_OPTIONS
              value: {{ include "golemio.maxOldSpaceSize" (index . "Values" $appSection "resources" "limits" "memory" ) | quote}}
            - name: POSTGRES_CONN
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.global.secretName }}
                  key: urlproxyPostgresConn
            - name: CRON_ENABLED
              value: "true"
            - name: GOLEMIO_API_V2_URL
              value: {{ index .Values $appSection "golemioApiV2Url" }}
            - name: GOLEMIO_API_V2_APIKEY
              valueFrom:
                secretKeyRef:
                  name: {{ .Values.global.secretName }}
                  key: urlproxyGolemioApiV2ApiKey
            - name: JAEGER_ENABLED
              value: {{ index .Values $appSection "opentelemetry" "enabled" | quote }}
            {{- if index .Values $appSection "opentelemetry" "enabled" }}
            - name: JAEGER_PROCESSOR
              value: {{ index .Values.opentelemetry.processor | upper | quote }}
            - name: JAEGER_AGENT_HOST
              value: {{ index .Values.opentelemetry.host | quote }}
            - name: JAEGER_AGENT_PORT
              value: {{ index .Values.opentelemetry.port | quote }}
            - name: OTEL_TRACES_SAMPLER
              value: {{ index .Values.opentelemetry.sampler | quote }}
            - name: OTEL_TRACES_SAMPLER_ARG
              value: {{ index .Values $appSection "opentelemetry" "samplerArg" | quote }}
            - name: TELEMETRY_LOG_LEVEL
              value: {{ index .Values.opentelemetry.logLevel | quote }}
            {{- end }}
            {{- if index . "Values" $appSection "inspector" "enabled" }}
            - name: INSPECTOR_HOST
              value: {{ index . "Values" $appSection "inspector" "host" | quote }}
            {{- end }}
{{ end }}
